Doomsday Engine - Bug #1591

[BSP] Fully overlapped map geometry is not always split
2013-10-18 10:55 - skyjake

Status: Progressed Start date: 2013-10-18
Priority: Low % Done: 50%
Assignee:

Category: Defect

Target version: Modding

Description

Fully overlapped map geometry is not always split when building the BSP (partial overlaps are split correctly).

Related issues:
Copied to Bug #2046: [BSP] Space partitioning results in superfluous line seg... Closed 2015-05-12

Associated revisions

Revision 6c6241f4 - 2014-10-27 15:30 - danij

Fixed|World|bsp::Partitioner: Space partitioning results in superfluous line segments
An overly conservative epsilon used when searching for existing line

segments in the map would sometimes lead to the creation of additional

line segments unnecessarily.

IssuelD #1591

History

#1 - 2013-10-18 10:56 - skyjake
- Description updated

#2 - 2013-10-18 20:20 - skyjake
- Category set to Defect

#3 - 2013-10-24 07:59 - skyjake

- Target version changed from 1.12.1 to 1.13

#4 - 2013-12-29 21:18 - skyjake

- Target version changed from 1.13 to 1.14

#5 - 2014-03-14 16:46 - danij

- Target version changed from 1.14 to 1.15

#6 - 2014-10-25 21:06 - danij

Closer inspection reveals there are actually two underlying issues here that result in geometry being split incorrectly. In addition to the known issue
with partially overlapped line segments, somehow the partitioner is dividing space in such a way as to induce the creation of the odd superfluous line
segment long before overlap-splitting begins.

Edit: Logic of divideSegments() and splitLineSegment() appears fine. Following a split the new segments are inserted back into the blockmap and are
processed again during the same divideSegments() call.

Edit2: Evidently addPartitionLineSegments() is erroneously creating a new segment on top of one that already exists in the map. Therefore this must
be either an "edge tip" or an intercept management issue.

Edit3: Yes, clearly this is an intercept problem. The requisite vertex edge tips for the soon-to-be overlapped geometry are present and correct.
Seemingly the problem lies with lineSegAtAngle()

Edit4: The logic of lineSegAtAngle() is fine, the issue is that epsilons aren't large enough for the segments to be detected (and thus affect the
outcome of the later addPartitionLineSegments()). As yet it is not clear whether simply relaxing the epsilon (say, 1.f/ 128) is a suitable fix.

Answer: Yes, this is a suitable short-term fix within the design of the current addPartitionLineSegments() algorithm. The existing tolerance is overly
conservative. This algorithm is however fundamentally flawed in that a fixed tolerance is applied regardless of the distance between a pair of
intercepts. A mathematically and geometrically proper fix would require a complete redesign of this algorithm.

#7 - 2014-10-25 23:42 - danij

- Status changed from New to In Progress

#8 - 2014-10-27 15:25 - danij
- File extrasegs.wad added

- % Done changed from 0 to 50
#9 - 2014-10-27 15:35 - danij
The issue with the creation of superfluous line segments has now been addressed for 1.15

The second issue concerning splitting of overlapped line segments wrt support of maphacks (such as those seen in the attached extrasegs.wad)
remains, however.

#10 - 2015-05-12 20:59 - skyjake
danij wrote:
The second issue concerning splitting of overlapped line segments wrt support of maphacks (such as those seen in the attached extrasegs.wad)

remains, however.

Are you planning to fix the second issue also for 1.15, or was the target version only for the first part? I'm not seeing how this is important enough to
hold the 1.15.0 release.

#11 - 2015-05-12 21:55 - danij

The 1.15 release target was indeed set because of the first part of this issue. As that is now addressed there is no reason to hold up the release
because the second part only affects a tiny percentage of user-made maps.

#12 - 2015-05-12 21:55 - danij
- Target version deleted (1.15)

#13 - 2015-05-12 23:05 - skyjake
- Copied to Bug #2046: [BSP] Space patrtitioning results in superfluous line segments added

#14 - 2015-05-12 23:06 - skyjake

Ok good. For bookkeeping | created a separate issue for the fix so it's included in 1.15.

#15 - 2016-07-06 00:05 - skyjake

- Status changed from In Progress to Progressed

#16 - 2017-04-03 14:40 - skyjake

- Target version set to Modding

#17 - 2019-11-29 23:06 - skyjake
- Assignee deleted (danij)

#18 - 2019-11-30 08:06 - skyjake

- Priority changed from Normal to Low

Files

extrasegs.wad 2.57 KB 2014-10-27 danij
